// Example1002B
// Sensor value is illustrated by
// color gradation(Fast LED), 
// LED blink (port 13), and serial print
// H. Kawakami, October, 2015

#include "FastLED.h"

const int NUM_LEDS = 1;
const int DATA_PIN = 4;  // tricolor led(FastLED)
CRGB leds[NUM_LEDS];

const int LED_PIN = 13; // unicolor led
const int SENSOR_PIN = A3; // distance measuring
int sensor;

void setup(){
  Serial.begin(9600);
  pinMode(LED_PIN, OUTPUT);
  FastLED.addLeds<WS2811, DATA_PIN, RGB>(leds, NUM_LEDS);
}

void loop(){
  distanceSensor();
  changeColor();
}

void distanceSensor(){
  sensor = analogRead(SENSOR_PIN);
  Serial.println(sensor);
  digitalWrite(LED_PIN, HIGH);
  delay(800-sensor);
  digitalWrite(LED_PIN, LOW);
  delay(800-sensor);
}

void changeColor(){
  sensor = analogRead(SENSOR_PIN);
  sensor = map(sensor, 800, 100, 0, 170);
//  Serial.println(sensor);
  fill_solid(&(leds[0]), NUM_LEDS, CHSV(sensor, 200, 200));
  FastLED.show();
}

