// Example1003
// calculate approximate distance in [6cmm, 30cm]
// H. Kawakami, October, 2015

const int LED_PIN = 13;
const int SENSOR_PIN = A3;

void setup(){
  Serial.begin(9600);
  pinMode(LED_PIN, OUTPUT);
}

void loop(){
  int sensor = analogRead(SENSOR_PIN);
  int svalue = sensor-200;

  Serial.print(sensor);
  Serial.print(",   ");
  int cm = appDist(svalue);
  Serial.println(cm);
  
  digitalWrite(LED_PIN, HIGH);
  delay(cm*10);
  digitalWrite(LED_PIN, LOW);
  delay(cm*10);
}

const int NUM_DATA = 6;
const int SCALE = 100;
static int dist[NUM_DATA]  = {30, 19, 14, 11, 8, 6};

//get approximate distance in [6cm , 30cm]
int appDist(int svalue){  
  if( svalue < 0 ) return dist[0];
  if( svalue >  SCALE*(NUM_DATA-1) )
      return dist[NUM_DATA-1];
  else{
      int i = svalue / SCALE;
      float frac = (svalue % SCALE) / (float)SCALE;
      return dist[i] - ((dist[i] - dist[i+1]) * frac);
  }
}

