// Example1003A
// calculate approximate distance
// H. Kawakami, October, 2015

#include <Wire.h>
#include <ST7032.h>

const int LED_PIN = 13;
const int SENSOR_PIN = A3;

ST7032 lcd;

void setup(){
  Serial.begin(9600);
  lcd.begin(8, 2);
  lcd.setContrast(30);
  pinMode(LED_PIN, OUTPUT);
}

void loop(){
  int sensor = analogRead(SENSOR_PIN);
  int svalue = sensor-200;
  int cm = appDist(svalue);

  printLCD(cm, sensor);
  blinkLED(cm);
}

void printLCD(int cm, int sensor){
  Serial.print(sensor);
  Serial.print(",");
  Serial.println(cm);
  lcd.clear();
  lcd.print(cm);
}

void blinkLED(int cm){
  digitalWrite(LED_PIN, HIGH);
  delay(cm*10);
  digitalWrite(LED_PIN, LOW);
  delay(cm*10);
}

const int NUM_DATA = 6;
const int SCALE = 100;
static int dist[NUM_DATA] = {30, 19, 14, 11, 8, 6};

int appDist(int svalue){  
  if(svalue < 0) return dist[0];
  if(svalue > SCALE*(NUM_DATA-1))
      return dist[NUM_DATA-1];
  else{  //get approximate distance in [6cm , 30cm]
      int i = svalue / SCALE;
      float frac = (svalue % SCALE) / (float)SCALE;
      return dist[i] - (dist[i] - dist[i+1])*frac;
  }
}

