//
// Example1004A: Another distance formula is used:
// see Slide No. 10, p. 18.
// H. Kawakami, October, 2015 

#include "FastLED.h"

#include <Wire.h>
#include <ST7032.h>

#define NUM_LEDS 1
#define DATA_PIN 4
#define SENSOR_PIN A3


ST7032 lcd;

CRGB leds[NUM_LEDS];
int sensor;

void setup() {
  Serial.begin(9600);
  lcd.begin(8, 2);
  lcd.setContrast(30);
  FastLED.addLeds<WS2811, DATA_PIN, RGB>(leds, NUM_LEDS);
}

void loop() {
  sensor=analogRead(SENSOR_PIN);
  float dist = 9973.04*pow(sensor, -1.0959);
  if(dist > 300) dist=300;
  Serial.println(dist);
  lcd.clear();
  lcd.print((int)dist);
  
  int dist_d=map(dist, 6, 40, 0, 170);
  fill_solid(&(leds[0]), NUM_LEDS, CHSV(dist_d, 200, 200));
  FastLED.show();
  delay(100);
}

